<script lang="ts">

import Station from "@/components/Station.vue"
import { defineComponent, ref } from "@vue/composition-api";
import { getConnection } from "@/plugins/connect"
import { StringCodec } from "nats.ws"
import { workstations, Workstation, CodeRecord, EPNMessage, DDR, NonePayload,  } from "@/model"

export default defineComponent({
	name: "Home",

	components: {
		Station
	},
	setup() {
		const nc = getConnection();
		const sc = StringCodec();

		let dialog = ref(false);
		let recordProperties = ref([] as string[]);
		function openDialog(station: Workstation, { record }: { record: CodeRecord }) {
			if (record.payloadType == NonePayload) {
				send(station, { record, payload: "{}" });
				return;
			}

			var obj = new record.payloadType();
			recordProperties.value = Object.getOwnPropertyNames(obj);
			dialog.value = true;
		}

		async function send(station: Workstation, { record, payload }: { record: CodeRecord, payload: string }) {
			var msg: EPNMessage = { code: record.code, label: record.label, payload: JSON.parse(payload) };

			(await nc)?.publish(station.label + (record.direction == DDR.FROM_SERVER ? ".job" : ".telemetry"), sc.encode(JSON.stringify(msg)));
		}

		return {
			workstations,
			dialog,
			recordProperties,
			openDialog,
			send
		}
	}
});
</script>


<template>
	<div>
		<v-dialog v-model="dialog">
			<v-card>
				<v-row v-for="property in recordProperties" :key="property">
					<v-col>{{ property }}: </v-col>
					<v+col>
						<v-text-field></v-text-field>
					</v+col>
				</v-row>
			</v-card>
		</v-dialog>
		<Station v-for="w in workstations" :key="w.name" :station="w" @send="openDialog(w, $event)"></Station>
	</div>
</template>

<style scoped>
	.v-dialog {
		width: 50%;
	}
</style>